/* editable-entry.c generated by valac 0.50.2, the Vala compiler
 * generated from editable-entry.vala, do not modify */

/* This file is part of GNOME Boxes. License: LGPLv2+*/
/* Boxes.EditableEntry is based on gnome-control-center CcEditableEntry*/

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>

#define BOXES_TYPE_EDITABLE_ENTRY (boxes_editable_entry_get_type ())
#define BOXES_EDITABLE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntry))
#define BOXES_EDITABLE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntryClass))
#define BOXES_IS_EDITABLE_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BOXES_TYPE_EDITABLE_ENTRY))
#define BOXES_IS_EDITABLE_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BOXES_TYPE_EDITABLE_ENTRY))
#define BOXES_EDITABLE_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntryClass))

typedef struct _BoxesEditableEntry BoxesEditableEntry;
typedef struct _BoxesEditableEntryClass BoxesEditableEntryClass;
typedef struct _BoxesEditableEntryPrivate BoxesEditableEntryPrivate;
enum  {
	BOXES_EDITABLE_ENTRY_0_PROPERTY,
	BOXES_EDITABLE_ENTRY_TEXT_PROPERTY,
	BOXES_EDITABLE_ENTRY_EDITABLE_PROPERTY,
	BOXES_EDITABLE_ENTRY_SELECTABLE_PROPERTY,
	BOXES_EDITABLE_ENTRY_TEXT_XALIGN_PROPERTY,
	BOXES_EDITABLE_ENTRY_TEXT_YALIGN_PROPERTY,
	BOXES_EDITABLE_ENTRY_WEIGHT_SET_PROPERTY,
	BOXES_EDITABLE_ENTRY_SCALE_PROPERTY,
	BOXES_EDITABLE_ENTRY_SCALE_SET_PROPERTY,
	BOXES_EDITABLE_ENTRY_NUM_PROPERTIES
};
static GParamSpec* boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_NUM_PROPERTIES];
typedef enum  {
	BOXES_EDITABLE_ENTRY_PAGE_LABEL,
	BOXES_EDITABLE_ENTRY_PAGE_BUTTON,
	BOXES_EDITABLE_ENTRY_PAGE_ENTRY
} BoxesEditableEntryPage;

#define BOXES_EDITABLE_ENTRY_TYPE_PAGE (boxes_editable_entry_page_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
enum  {
	BOXES_EDITABLE_ENTRY_EDITING_DONE_SIGNAL,
	BOXES_EDITABLE_ENTRY_NUM_SIGNALS
};
static guint boxes_editable_entry_signals[BOXES_EDITABLE_ENTRY_NUM_SIGNALS] = {0};

struct _BoxesEditableEntry {
	GtkNotebook parent_instance;
	BoxesEditableEntryPrivate * priv;
	gboolean _editable;
};

struct _BoxesEditableEntryClass {
	GtkNotebookClass parent_class;
};

struct _BoxesEditableEntryPrivate {
	gchar* _text;
	PangoWeight _weight;
	gboolean _weight_set;
	gdouble _scale;
	gboolean _scale_set;
	GtkLabel* label;
	GtkLabel* button_label;
	GtkEntry* entry;
	gboolean in_stop_editing;
};

static gint BoxesEditableEntry_private_offset;
static gpointer boxes_editable_entry_parent_class = NULL;

#define EMPTY_TEXT "\xe2\x80\x94"
GType boxes_editable_entry_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BoxesEditableEntry, g_object_unref)
static GType boxes_editable_entry_page_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void boxes_editable_entry_update_entry_font (BoxesEditableEntry* self,
                                             GtkEntry* entry);
gboolean boxes_editable_entry_get_scale_set (BoxesEditableEntry* self);
gboolean boxes_editable_entry_get_weight_set (BoxesEditableEntry* self);
static PangoFontDescription* _vala_PangoFontDescription_copy (PangoFontDescription* self);
gdouble boxes_editable_entry_get_scale (BoxesEditableEntry* self);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void boxes_editable_entry_update_fonts (BoxesEditableEntry* self);
void boxes_editable_entry_start_editing (BoxesEditableEntry* self);
static void boxes_editable_entry_stop_editing (BoxesEditableEntry* self);
void boxes_editable_entry_set_text (BoxesEditableEntry* self,
                                    const gchar* value);
static void boxes_editable_entry_cancel_editing (BoxesEditableEntry* self);
const gchar* boxes_editable_entry_get_text (BoxesEditableEntry* self);
BoxesEditableEntry* boxes_editable_entry_new (void);
BoxesEditableEntry* boxes_editable_entry_construct (GType object_type);
static void boxes_editable_entry_on_button_clicked (BoxesEditableEntry* self);
static void _boxes_editable_entry_on_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
static void boxes_editable_entry_on_button_label_size_allocate (BoxesEditableEntry* self,
                                                         GtkWidget* widget,
                                                         GtkAllocation* allocation);
static void _boxes_editable_entry_on_button_label_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                                   GtkAllocation* allocation,
                                                                                   gpointer self);
static void boxes_editable_entry_on_entry_activated (BoxesEditableEntry* self);
static void _boxes_editable_entry_on_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                                  gpointer self);
static gboolean boxes_editable_entry_on_entry_focused_out (BoxesEditableEntry* self);
static gboolean _boxes_editable_entry_on_entry_focused_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                                GdkEventFocus* event,
                                                                                gpointer self);
static gboolean boxes_editable_entry_on_entry_key_press_event (BoxesEditableEntry* self,
                                                        GtkWidget* widget,
                                                        GdkEventKey* event);
static gboolean _boxes_editable_entry_on_entry_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                    GdkEventKey* event,
                                                                                    gpointer self);
static void boxes_editable_entry_on_entry_style_updated (BoxesEditableEntry* self);
static void _boxes_editable_entry_on_entry_style_updated_gtk_widget_style_updated (GtkWidget* _sender,
                                                                            gpointer self);
gboolean boxes_editable_entry_get_editable (BoxesEditableEntry* self);
void boxes_editable_entry_set_editable (BoxesEditableEntry* self,
                                        gboolean value);
gboolean boxes_editable_entry_get_selectable (BoxesEditableEntry* self);
void boxes_editable_entry_set_selectable (BoxesEditableEntry* self,
                                          gboolean value);
gfloat boxes_editable_entry_get_text_xalign (BoxesEditableEntry* self);
void boxes_editable_entry_set_text_xalign (BoxesEditableEntry* self,
                                           gfloat value);
gfloat boxes_editable_entry_get_text_yalign (BoxesEditableEntry* self);
void boxes_editable_entry_set_text_yalign (BoxesEditableEntry* self,
                                           gfloat value);
void boxes_editable_entry_set_weight_set (BoxesEditableEntry* self,
                                          gboolean value);
void boxes_editable_entry_set_scale (BoxesEditableEntry* self,
                                     gdouble value);
void boxes_editable_entry_set_scale_set (BoxesEditableEntry* self,
                                         gboolean value);
static void boxes_editable_entry_finalize (GObject * obj);
static GType boxes_editable_entry_get_type_once (void);
static void _vala_boxes_editable_entry_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_boxes_editable_entry_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
boxes_editable_entry_get_instance_private (BoxesEditableEntry* self)
{
	return G_STRUCT_MEMBER_P (self, BoxesEditableEntry_private_offset);
}

static GType
boxes_editable_entry_page_get_type_once (void)
{
	static const GEnumValue values[] = {{BOXES_EDITABLE_ENTRY_PAGE_LABEL, "BOXES_EDITABLE_ENTRY_PAGE_LABEL", "label"}, {BOXES_EDITABLE_ENTRY_PAGE_BUTTON, "BOXES_EDITABLE_ENTRY_PAGE_BUTTON", "button"}, {BOXES_EDITABLE_ENTRY_PAGE_ENTRY, "BOXES_EDITABLE_ENTRY_PAGE_ENTRY", "entry"}, {0, NULL, NULL}};
	GType boxes_editable_entry_page_type_id;
	boxes_editable_entry_page_type_id = g_enum_register_static ("BoxesEditableEntryPage", values);
	return boxes_editable_entry_page_type_id;
}

static GType
boxes_editable_entry_page_get_type (void)
{
	static volatile gsize boxes_editable_entry_page_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_editable_entry_page_type_id__volatile)) {
		GType boxes_editable_entry_page_type_id;
		boxes_editable_entry_page_type_id = boxes_editable_entry_page_get_type_once ();
		g_once_init_leave (&boxes_editable_entry_page_type_id__volatile, boxes_editable_entry_page_type_id);
	}
	return boxes_editable_entry_page_type_id__volatile;
}

static PangoFontDescription*
_vala_PangoFontDescription_copy (PangoFontDescription* self)
{
	return g_boxed_copy (pango_font_description_get_type (), self);
}

static gpointer
__vala_PangoFontDescription_copy0 (gpointer self)
{
	return self ? _vala_PangoFontDescription_copy (self) : NULL;
}

static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
	g_boxed_free (pango_font_description_get_type (), self);
}

static void
boxes_editable_entry_update_entry_font (BoxesEditableEntry* self,
                                        GtkEntry* entry)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	PangoFontDescription* desc = NULL;
	GtkStyleContext* _tmp3_;
	PangoFontDescription* _tmp4_;
	PangoFontDescription* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp9_;
	PangoFontDescription* _tmp14_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	_tmp1_ = self->priv->_scale_set;
	if (!_tmp1_) {
		gboolean _tmp2_;
		_tmp2_ = self->priv->_weight_set;
		_tmp0_ = !_tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	g_signal_handlers_block_by_func (entry, (void*) boxes_editable_entry_update_entry_font, self);
	gtk_widget_override_font ((GtkWidget*) entry, NULL);
	_tmp3_ = gtk_widget_get_style_context ((GtkWidget*) entry);
	_tmp4_ = gtk_style_context_get_font (_tmp3_, gtk_widget_get_state_flags ((GtkWidget*) entry));
	_tmp5_ = __vala_PangoFontDescription_copy0 (_tmp4_);
	desc = _tmp5_;
	_tmp6_ = self->priv->_weight_set;
	if (_tmp6_) {
		PangoFontDescription* _tmp7_;
		PangoWeight _tmp8_;
		_tmp7_ = desc;
		_tmp8_ = self->priv->_weight;
		pango_font_description_set_weight (_tmp7_, _tmp8_);
	}
	_tmp9_ = self->priv->_scale_set;
	if (_tmp9_) {
		PangoFontDescription* _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		PangoFontDescription* _tmp13_;
		_tmp10_ = desc;
		_tmp11_ = boxes_editable_entry_get_scale (self);
		_tmp12_ = _tmp11_;
		_tmp13_ = desc;
		pango_font_description_set_size (_tmp10_, (gint) (_tmp12_ * pango_font_description_get_size (_tmp13_)));
	}
	_tmp14_ = desc;
	gtk_widget_override_font ((GtkWidget*) entry, _tmp14_);
	g_signal_handlers_unblock_by_func (entry, (void*) boxes_editable_entry_update_entry_font, self);
	__vala_PangoFontDescription_free0 (desc);
}

static void
boxes_editable_entry_update_fonts (BoxesEditableEntry* self)
{
	PangoAttrList* attrs = NULL;
	PangoAttrList* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp6_;
	GtkLabel* _tmp10_;
	PangoAttrList* _tmp11_;
	GtkLabel* _tmp12_;
	PangoAttrList* _tmp13_;
	GtkEntry* _tmp14_;
	g_return_if_fail (self != NULL);
	_tmp0_ = pango_attr_list_new ();
	attrs = _tmp0_;
	_tmp1_ = self->priv->_scale_set;
	if (_tmp1_) {
		PangoAttrList* _tmp2_;
		gdouble _tmp3_;
		gdouble _tmp4_;
		PangoAttribute* _tmp5_;
		_tmp2_ = attrs;
		_tmp3_ = boxes_editable_entry_get_scale (self);
		_tmp4_ = _tmp3_;
		_tmp5_ = pango_attr_scale_new (_tmp4_);
		pango_attr_list_insert (_tmp2_, _tmp5_);
	}
	_tmp6_ = self->priv->_weight_set;
	if (_tmp6_) {
		PangoAttrList* _tmp7_;
		PangoWeight _tmp8_;
		PangoAttribute* _tmp9_;
		_tmp7_ = attrs;
		_tmp8_ = self->priv->_weight;
		_tmp9_ = pango_attr_weight_new (_tmp8_);
		pango_attr_list_insert (_tmp7_, _tmp9_);
	}
	_tmp10_ = self->priv->label;
	_tmp11_ = attrs;
	gtk_label_set_attributes (_tmp10_, _tmp11_);
	_tmp12_ = self->priv->button_label;
	_tmp13_ = attrs;
	gtk_label_set_attributes (_tmp12_, _tmp13_);
	_tmp14_ = self->priv->entry;
	boxes_editable_entry_update_entry_font (self, _tmp14_);
	_pango_attr_list_unref0 (attrs);
}

void
boxes_editable_entry_start_editing (BoxesEditableEntry* self)
{
	g_return_if_fail (self != NULL);
	g_object_set ((GtkNotebook*) self, "page", (gint) BOXES_EDITABLE_ENTRY_PAGE_ENTRY, NULL);
}

static void
boxes_editable_entry_stop_editing (BoxesEditableEntry* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	if (self->priv->in_stop_editing) {
		return;
	}
	self->priv->in_stop_editing = TRUE;
	g_object_set ((GtkNotebook*) self, "page", (gint) BOXES_EDITABLE_ENTRY_PAGE_BUTTON, NULL);
	_tmp0_ = self->priv->entry;
	_tmp1_ = gtk_entry_get_text (_tmp0_);
	_tmp2_ = _tmp1_;
	boxes_editable_entry_set_text (self, _tmp2_);
	g_signal_emit (self, boxes_editable_entry_signals[BOXES_EDITABLE_ENTRY_EDITING_DONE_SIGNAL], 0);
	self->priv->in_stop_editing = FALSE;
}

static void
boxes_editable_entry_cancel_editing (BoxesEditableEntry* self)
{
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->entry;
	_tmp1_ = boxes_editable_entry_get_text (self);
	_tmp2_ = _tmp1_;
	gtk_entry_set_text (_tmp0_, _tmp2_);
	g_object_set ((GtkNotebook*) self, "page", (gint) BOXES_EDITABLE_ENTRY_PAGE_BUTTON, NULL);
}

BoxesEditableEntry*
boxes_editable_entry_construct (GType object_type)
{
	BoxesEditableEntry * self = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	self = (BoxesEditableEntry*) g_object_new (object_type, NULL);
	_tmp0_ = self->priv->label;
	gtk_label_set_label (_tmp0_, EMPTY_TEXT);
	_tmp1_ = self->priv->button_label;
	gtk_label_set_label (_tmp1_, EMPTY_TEXT);
	return self;
}

BoxesEditableEntry*
boxes_editable_entry_new (void)
{
	return boxes_editable_entry_construct (BOXES_TYPE_EDITABLE_ENTRY);
}

static void
boxes_editable_entry_on_button_clicked (BoxesEditableEntry* self)
{
	g_return_if_fail (self != NULL);
	boxes_editable_entry_start_editing (self);
}

static void
_boxes_editable_entry_on_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
	boxes_editable_entry_on_button_clicked ((BoxesEditableEntry*) self);
}

static void
boxes_editable_entry_on_button_label_size_allocate (BoxesEditableEntry* self,
                                                    GtkWidget* widget,
                                                    GtkAllocation* allocation)
{
	GtkAllocation alloc = {0};
	GtkContainer* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	gint offset = 0;
	GtkAllocation _tmp2_;
	GtkAllocation _tmp3_;
	GtkLabel* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	g_return_if_fail (allocation != NULL);
	_tmp0_ = gtk_widget_get_parent (widget);
	gtk_widget_get_allocation ((GtkWidget*) _tmp0_, &_tmp1_);
	alloc = _tmp1_;
	_tmp2_ = *allocation;
	_tmp3_ = alloc;
	offset = _tmp2_.x - _tmp3_.x;
	_tmp4_ = self->priv->label;
	_tmp5_ = gtk_widget_get_margin_start ((GtkWidget*) _tmp4_);
	_tmp6_ = _tmp5_;
	if (offset != _tmp6_) {
		GtkLabel* _tmp7_;
		_tmp7_ = self->priv->label;
		gtk_misc_set_padding ((GtkMisc*) _tmp7_, offset, 0);
	}
}

static void
_boxes_editable_entry_on_button_label_size_allocate_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                              GtkAllocation* allocation,
                                                                              gpointer self)
{
	boxes_editable_entry_on_button_label_size_allocate ((BoxesEditableEntry*) self, _sender, allocation);
}

static void
boxes_editable_entry_on_entry_activated (BoxesEditableEntry* self)
{
	g_return_if_fail (self != NULL);
	boxes_editable_entry_stop_editing (self);
}

static void
_boxes_editable_entry_on_entry_activated_gtk_entry_activate (GtkEntry* _sender,
                                                             gpointer self)
{
	boxes_editable_entry_on_entry_activated ((BoxesEditableEntry*) self);
}

static gboolean
boxes_editable_entry_on_entry_focused_out (BoxesEditableEntry* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	boxes_editable_entry_stop_editing (self);
	result = FALSE;
	return result;
}

static gboolean
_boxes_editable_entry_on_entry_focused_out_gtk_widget_focus_out_event (GtkWidget* _sender,
                                                                       GdkEventFocus* event,
                                                                       gpointer self)
{
	gboolean result;
	result = boxes_editable_entry_on_entry_focused_out ((BoxesEditableEntry*) self);
	return result;
}

static gboolean
boxes_editable_entry_on_entry_key_press_event (BoxesEditableEntry* self,
                                               GtkWidget* widget,
                                               GdkEventKey* event)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (event != NULL, FALSE);
	if (event->keyval == GDK_KEY_Escape) {
		boxes_editable_entry_cancel_editing (self);
	}
	result = FALSE;
	return result;
}

static gboolean
_boxes_editable_entry_on_entry_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                           GdkEventKey* event,
                                                                           gpointer self)
{
	gboolean result;
	result = boxes_editable_entry_on_entry_key_press_event ((BoxesEditableEntry*) self, _sender, event);
	return result;
}

static void
boxes_editable_entry_on_entry_style_updated (BoxesEditableEntry* self)
{
	GtkEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->entry;
	boxes_editable_entry_update_entry_font (self, G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_entry_get_type ()) ? ((GtkEntry*) _tmp0_) : NULL);
}

static void
_boxes_editable_entry_on_entry_style_updated_gtk_widget_style_updated (GtkWidget* _sender,
                                                                       gpointer self)
{
	boxes_editable_entry_on_entry_style_updated ((BoxesEditableEntry*) self);
}

const gchar*
boxes_editable_entry_get_text (BoxesEditableEntry* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_text;
	result = _tmp0_;
	return result;
}

void
boxes_editable_entry_set_text (BoxesEditableEntry* self,
                               const gchar* value)
{
	gchar* _tmp0_;
	GtkEntry* _tmp1_;
	gboolean _tmp2_ = FALSE;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_text);
	self->priv->_text = _tmp0_;
	_tmp1_ = self->priv->entry;
	gtk_entry_set_text (_tmp1_, value);
	if (value == NULL) {
		_tmp2_ = TRUE;
	} else {
		gint _tmp3_;
		gint _tmp4_;
		_tmp3_ = strlen (value);
		_tmp4_ = _tmp3_;
		_tmp2_ = _tmp4_ == 0;
	}
	if (_tmp2_) {
		value = EMPTY_TEXT;
	}
	_tmp5_ = self->priv->label;
	gtk_label_set_label (_tmp5_, value);
	_tmp6_ = self->priv->button_label;
	gtk_label_set_label (_tmp6_, value);
	g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_TEXT_PROPERTY]);
}

gboolean
boxes_editable_entry_get_editable (BoxesEditableEntry* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->_editable;
	return result;
}

void
boxes_editable_entry_set_editable (BoxesEditableEntry* self,
                                   gboolean value)
{
	BoxesEditableEntryPage _tmp0_ = 0;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	if (value == self->_editable) {
		return;
	}
	self->_editable = value;
	_tmp1_ = boxes_editable_entry_get_editable (self);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = BOXES_EDITABLE_ENTRY_PAGE_BUTTON;
	} else {
		_tmp0_ = BOXES_EDITABLE_ENTRY_PAGE_LABEL;
	}
	g_object_set ((GtkNotebook*) self, "page", (gint) _tmp0_, NULL);
	g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_EDITABLE_PROPERTY]);
}

gboolean
boxes_editable_entry_get_selectable (BoxesEditableEntry* self)
{
	gboolean result;
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->label;
	_tmp1_ = gtk_label_get_selectable (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
boxes_editable_entry_set_selectable (BoxesEditableEntry* self,
                                     gboolean value)
{
	GtkLabel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkLabel* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	_tmp1_ = gtk_label_get_selectable (_tmp0_);
	_tmp2_ = _tmp1_;
	if (value == _tmp2_) {
		return;
	}
	_tmp3_ = self->priv->label;
	gtk_label_set_selectable (_tmp3_, value);
	g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_SELECTABLE_PROPERTY]);
}

gfloat
boxes_editable_entry_get_text_xalign (BoxesEditableEntry* self)
{
	gfloat result;
	GtkLabel* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	g_return_val_if_fail (self != NULL, 0.0F);
	_tmp0_ = self->priv->label;
	_tmp1_ = gtk_label_get_xalign (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
boxes_editable_entry_set_text_xalign (BoxesEditableEntry* self,
                                      gfloat value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkEntry* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	gtk_label_set_xalign (_tmp0_, value);
	_tmp1_ = self->priv->button_label;
	gtk_label_set_xalign (_tmp1_, value);
	_tmp2_ = self->priv->entry;
	g_object_set (_tmp2_, "xalign", value, NULL);
	g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_TEXT_XALIGN_PROPERTY]);
}

gfloat
boxes_editable_entry_get_text_yalign (BoxesEditableEntry* self)
{
	gfloat result;
	GtkLabel* _tmp0_;
	gfloat _tmp1_;
	gfloat _tmp2_;
	g_return_val_if_fail (self != NULL, 0.0F);
	_tmp0_ = self->priv->label;
	_tmp1_ = gtk_label_get_yalign (_tmp0_);
	_tmp2_ = _tmp1_;
	result = _tmp2_;
	return result;
}

void
boxes_editable_entry_set_text_yalign (BoxesEditableEntry* self,
                                      gfloat value)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->label;
	gtk_label_set_yalign (_tmp0_, value);
	_tmp1_ = self->priv->button_label;
	gtk_label_set_yalign (_tmp1_, value);
	g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_TEXT_YALIGN_PROPERTY]);
}

gboolean
boxes_editable_entry_get_weight_set (BoxesEditableEntry* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_weight_set;
	return result;
}

void
boxes_editable_entry_set_weight_set (BoxesEditableEntry* self,
                                     gboolean value)
{
	g_return_if_fail (self != NULL);
	if (boxes_editable_entry_get_weight_set (self) != value) {
		self->priv->_weight_set = value;
		g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_WEIGHT_SET_PROPERTY]);
	}
}

gdouble
boxes_editable_entry_get_scale (BoxesEditableEntry* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_scale;
	return result;
}

void
boxes_editable_entry_set_scale (BoxesEditableEntry* self,
                                gdouble value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value == self->priv->_scale) {
		gboolean _tmp1_;
		_tmp1_ = self->priv->_scale_set;
		_tmp0_ = _tmp1_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	self->priv->_scale = value;
	boxes_editable_entry_set_scale_set (self, TRUE);
	boxes_editable_entry_update_fonts (self);
	g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_SCALE_PROPERTY]);
}

gboolean
boxes_editable_entry_get_scale_set (BoxesEditableEntry* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_scale_set;
	return result;
}

void
boxes_editable_entry_set_scale_set (BoxesEditableEntry* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	if (boxes_editable_entry_get_scale_set (self) != value) {
		self->priv->_scale_set = value;
		g_object_notify_by_pspec ((GObject *) self, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_SCALE_SET_PROPERTY]);
	}
}

static void
boxes_editable_entry_class_init (BoxesEditableEntryClass * klass,
                                 gpointer klass_data)
{
	boxes_editable_entry_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BoxesEditableEntry_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_boxes_editable_entry_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_boxes_editable_entry_set_property;
	G_OBJECT_CLASS (klass)->finalize = boxes_editable_entry_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_TEXT_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_EDITABLE_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_EDITABLE_PROPERTY] = g_param_spec_boolean ("editable", "editable", "editable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_SELECTABLE_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_SELECTABLE_PROPERTY] = g_param_spec_boolean ("selectable", "selectable", "selectable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_TEXT_XALIGN_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_TEXT_XALIGN_PROPERTY] = g_param_spec_float ("text-xalign", "text-xalign", "text-xalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_TEXT_YALIGN_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_TEXT_YALIGN_PROPERTY] = g_param_spec_float ("text-yalign", "text-yalign", "text-yalign", -G_MAXFLOAT, G_MAXFLOAT, 0.0F, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_WEIGHT_SET_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_WEIGHT_SET_PROPERTY] = g_param_spec_boolean ("weight-set", "weight-set", "weight-set", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_SCALE_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_SCALE_PROPERTY] = g_param_spec_double ("scale", "scale", "scale", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOXES_EDITABLE_ENTRY_SCALE_SET_PROPERTY, boxes_editable_entry_properties[BOXES_EDITABLE_ENTRY_SCALE_SET_PROPERTY] = g_param_spec_boolean ("scale-set", "scale-set", "scale-set", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Boxes/ui/editable-entry.ui");
	boxes_editable_entry_signals[BOXES_EDITABLE_ENTRY_EDITING_DONE_SIGNAL] = g_signal_new ("editing-done", BOXES_TYPE_EDITABLE_ENTRY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "label", FALSE, BoxesEditableEntry_private_offset + G_STRUCT_OFFSET (BoxesEditableEntryPrivate, label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "button_label", FALSE, BoxesEditableEntry_private_offset + G_STRUCT_OFFSET (BoxesEditableEntryPrivate, button_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "entry", FALSE, BoxesEditableEntry_private_offset + G_STRUCT_OFFSET (BoxesEditableEntryPrivate, entry));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_clicked", G_CALLBACK(_boxes_editable_entry_on_button_clicked_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_button_label_size_allocate", G_CALLBACK(_boxes_editable_entry_on_button_label_size_allocate_gtk_widget_size_allocate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_activated", G_CALLBACK(_boxes_editable_entry_on_entry_activated_gtk_entry_activate));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_focused_out", G_CALLBACK(_boxes_editable_entry_on_entry_focused_out_gtk_widget_focus_out_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_key_press_event", G_CALLBACK(_boxes_editable_entry_on_entry_key_press_event_gtk_widget_key_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_entry_style_updated", G_CALLBACK(_boxes_editable_entry_on_entry_style_updated_gtk_widget_style_updated));
}

static void
boxes_editable_entry_instance_init (BoxesEditableEntry * self,
                                    gpointer klass)
{
	self->priv = boxes_editable_entry_get_instance_private (self);
	self->priv->_weight = PANGO_WEIGHT_NORMAL;
	self->priv->_scale = 1.0;
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
boxes_editable_entry_finalize (GObject * obj)
{
	BoxesEditableEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntry);
	_g_free0 (self->priv->_text);
	_g_object_unref0 (self->priv->label);
	_g_object_unref0 (self->priv->button_label);
	_g_object_unref0 (self->priv->entry);
	G_OBJECT_CLASS (boxes_editable_entry_parent_class)->finalize (obj);
}

static GType
boxes_editable_entry_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BoxesEditableEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) boxes_editable_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BoxesEditableEntry), 0, (GInstanceInitFunc) boxes_editable_entry_instance_init, NULL };
	GType boxes_editable_entry_type_id;
	boxes_editable_entry_type_id = g_type_register_static (gtk_notebook_get_type (), "BoxesEditableEntry", &g_define_type_info, 0);
	BoxesEditableEntry_private_offset = g_type_add_instance_private (boxes_editable_entry_type_id, sizeof (BoxesEditableEntryPrivate));
	return boxes_editable_entry_type_id;
}

GType
boxes_editable_entry_get_type (void)
{
	static volatile gsize boxes_editable_entry_type_id__volatile = 0;
	if (g_once_init_enter (&boxes_editable_entry_type_id__volatile)) {
		GType boxes_editable_entry_type_id;
		boxes_editable_entry_type_id = boxes_editable_entry_get_type_once ();
		g_once_init_leave (&boxes_editable_entry_type_id__volatile, boxes_editable_entry_type_id);
	}
	return boxes_editable_entry_type_id__volatile;
}

static void
_vala_boxes_editable_entry_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BoxesEditableEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntry);
	switch (property_id) {
		case BOXES_EDITABLE_ENTRY_TEXT_PROPERTY:
		g_value_set_string (value, boxes_editable_entry_get_text (self));
		break;
		case BOXES_EDITABLE_ENTRY_EDITABLE_PROPERTY:
		g_value_set_boolean (value, boxes_editable_entry_get_editable (self));
		break;
		case BOXES_EDITABLE_ENTRY_SELECTABLE_PROPERTY:
		g_value_set_boolean (value, boxes_editable_entry_get_selectable (self));
		break;
		case BOXES_EDITABLE_ENTRY_TEXT_XALIGN_PROPERTY:
		g_value_set_float (value, boxes_editable_entry_get_text_xalign (self));
		break;
		case BOXES_EDITABLE_ENTRY_TEXT_YALIGN_PROPERTY:
		g_value_set_float (value, boxes_editable_entry_get_text_yalign (self));
		break;
		case BOXES_EDITABLE_ENTRY_WEIGHT_SET_PROPERTY:
		g_value_set_boolean (value, boxes_editable_entry_get_weight_set (self));
		break;
		case BOXES_EDITABLE_ENTRY_SCALE_PROPERTY:
		g_value_set_double (value, boxes_editable_entry_get_scale (self));
		break;
		case BOXES_EDITABLE_ENTRY_SCALE_SET_PROPERTY:
		g_value_set_boolean (value, boxes_editable_entry_get_scale_set (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_boxes_editable_entry_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BoxesEditableEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BOXES_TYPE_EDITABLE_ENTRY, BoxesEditableEntry);
	switch (property_id) {
		case BOXES_EDITABLE_ENTRY_TEXT_PROPERTY:
		boxes_editable_entry_set_text (self, g_value_get_string (value));
		break;
		case BOXES_EDITABLE_ENTRY_EDITABLE_PROPERTY:
		boxes_editable_entry_set_editable (self, g_value_get_boolean (value));
		break;
		case BOXES_EDITABLE_ENTRY_SELECTABLE_PROPERTY:
		boxes_editable_entry_set_selectable (self, g_value_get_boolean (value));
		break;
		case BOXES_EDITABLE_ENTRY_TEXT_XALIGN_PROPERTY:
		boxes_editable_entry_set_text_xalign (self, g_value_get_float (value));
		break;
		case BOXES_EDITABLE_ENTRY_TEXT_YALIGN_PROPERTY:
		boxes_editable_entry_set_text_yalign (self, g_value_get_float (value));
		break;
		case BOXES_EDITABLE_ENTRY_WEIGHT_SET_PROPERTY:
		boxes_editable_entry_set_weight_set (self, g_value_get_boolean (value));
		break;
		case BOXES_EDITABLE_ENTRY_SCALE_PROPERTY:
		boxes_editable_entry_set_scale (self, g_value_get_double (value));
		break;
		case BOXES_EDITABLE_ENTRY_SCALE_SET_PROPERTY:
		boxes_editable_entry_set_scale_set (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

